package CustomPermalink;

use strict;
use MT::Template::Tags::Entry;
use MT::Template::Tags::Archive;
use MT::Template::Tags::Category;

sub _plugin {
    return MT::Plugin::CustomPermalink->instance();
}

sub _hdlr_custom_entry_permalink {
    my ($ctx, $args, $cond) = @_;
    my $app = MT->instance();
    my $res = MT::Template::Tags::Entry::_hdlr_entry_link($ctx, $args, $cond);

    return _plugin()->enabled($app->blog->id) ? _plugin()->replace($res) : $res;
}

sub _hdlr_custom_page_permalink {
    return undef unless $_[0]->check_page();
    shift->invoke_handler('customentrypermalink', @_);
}

sub _hdlr_custom_category_archive {
    my ($ctx, $args, $cond) = @_;
    my $app = MT->instance();
    my $res = MT::Template::Tags::Category::_hdlr_category_archive($ctx, $args, $cond);

    return _plugin()->enabled($app->blog->id) ? _plugin()->replace($res) : $res;
}

sub _hdlr_custom_archive_link {
    my ($ctx, $args, $cond) = @_;
    my $app = MT->instance();
    my $res = MT::Template::Tags::Archive::_hdlr_archive_link($ctx, $args, $cond);

    return _plugin()->enabled($app->blog->id) ? _plugin()->replace($res) : $res;
}

sub _fltr_custom_permalink {
    my ($str, $arg, $ctx) = @_;
    my $app = MT->instance();

    return _plugin()->enabled($app->blog->id) ? _plugin()->replace($str) : $str;
}

1;