package CustomPermalink::CMS;

use strict;

sub _plugin {
    return MT::Plugin::CustomPermalink->instance();
}

sub add_pair {
    my $app = shift;

    if (!$app->user->is_superuser() && !$app->user->permissions($app->blog->id)->can_administer_blog()) {
        return _plugin()->translate("Permission denied.");
    }

    my %param;
    $param{blog_id} = $app->blog->id if $app->blog;
    my $dialog_tmpl = _plugin()->load_tmpl('dialog_add_pair.tmpl');

    return $app->build_page($dialog_tmpl, \%param);
}

sub template_source_entry_table {
    my ($cb, $app, $tmpl) = @_;

    my $old = q!<\$?mt:var name="entry_permalink"\$?>!;
    my $new = q!<$mt:var name="entry_permalink" custom_permalink="1"$>!;
    $$tmpl =~ s/$old/$new/ig;
}

sub template_source_edit_entry {
    my ($cb, $app, $tmpl) = @_;

    my $old = q!<\$?mt:var name="entry_permalink"\$?>!;
    my $new = q!<$mt:var name="entry_permalink" custom_permalink="1"$>!;
    $$tmpl =~ s/$old/$new/ig;
}

sub template_source_preview_strip {
    my ($cb, $app, $tmpl) = @_;

    my $old = q!<\$?mt:var name="preview_url"\$?>!;
    my $new = q!<$mt:var name="preview_url" custom_permalink="1"$>!;
    $$tmpl =~ s/$old/$new/ig;
}

1;